package nstaclient

import "fmt"

// Error implements a transfer specific error
type Error struct {
	Name    string
	Message string
	Err     error
}

// Unwrap implements errors.Unwrap
func (e *Error) Unwrap() error {
	return e.Err
}

// Unwrap implements errors.Error
func (e *Error) Error() string {
	if e.Err != nil {
		if e.Message != "" {
			return fmt.Sprintf("[%s] %s: %s", e.Name, e.Message, e.Err.Error())
		}
		return fmt.Sprintf("[%s] %s", e.Name, e.Err.Error())
	}
	return fmt.Sprintf("[%s] %s", e.Name, e.Message)
}
